package wenrgise.hrms.ejb.business;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import wenrgise.common.bean.BaseHeaderBean;
import wenrgise.common.exception.EnrgiseApplicationException;
import wenrgise.common.exception.EnrgiseMessageKeyException;
import wenrgise.common.exception.EnrgiseSystemException;
import wenrgise.common.utility.EnrgiseUtil;
import wenrgise.common.utility.MessageKey;
import wenrgise.common.utility.RecordMetaInfo;
import wenrgise.common.utility.UserInfo;
import wenrgise.common.vo.BaseDetailVO;
import wenrgise.ejb.common.helper.DBObject;
import wenrgise.ejb.common.helper.QueryRow;
import wenrgise.ejb.common.helper.QueryValue;
import wenrgise.ejb.common.utility.DBUtilitiesBean;
import wenrgise.hrms.bean.HrmOrgDistrictMstDtlBean;

public class HrmOrgDistMstBO extends HrmBaseBO {
  public HrmOrgDistMstBO() {}
  
  public HrmOrgDistMstBO(UserInfo oUserInfo) {
    super(oUserInfo);
  }
  
  public RecordMetaInfo getHrmDistrictDtlMetaInfo(String lPrimaryKey) throws EnrgiseApplicationException, EnrgiseSystemException {
    ArrayList arylstParameters = new ArrayList();
    DBUtilitiesBean oBean = new DBUtilitiesBean();
    arylstParameters = new ArrayList();
    arylstParameters.add(new DBObject(1, 2, -5));
    arylstParameters.add(new DBObject(2, 2, 93));
    arylstParameters.add(new DBObject(3, 2, 12));
    arylstParameters.add(new DBObject(4, 2, 12));
    arylstParameters.add(new DBObject(5, 2, 4));
    ArrayList arylstOutArray = oBean.callProc(arylstParameters, "HRMORGDISTRICTMST.proc_HrDistrictDtlCount(?,?,?,?,?)");
    RecordMetaInfo oRecordMetaInfo = new RecordMetaInfo();
    DBObject oTotalRecord = arylstOutArray.get(0);
    oRecordMetaInfo.setRecordCount(((Long)oTotalRecord.getObject()).longValue());
    DBObject oTimeObject = arylstOutArray.get(1);
    oRecordMetaInfo.setOWhenPicked((Timestamp)oTimeObject.getObject());
    return oRecordMetaInfo;
  }
  
  public ArrayList getHrmDistrictDetailInfo(String lPrimaryKey, long lDetailFirstPosition, long lDetailLastPosition) throws EnrgiseApplicationException, EnrgiseSystemException {
    ArrayList arylstParameters = new ArrayList();
    DBUtilitiesBean oBean = new DBUtilitiesBean();
    int count = 0;
    BaseDetailVO oBaseDetailVO = null;
    ArrayList arylstHrmDistrictDetail = null;
    arylstParameters = new ArrayList();
    arylstParameters.add(new DBObject(1, 1, -5, new Long(lDetailFirstPosition)));
    arylstParameters.add(new DBObject(2, 1, -5, new Long(lDetailLastPosition)));
    arylstParameters.add(new DBObject(3, 2, -10));
    arylstParameters.add(new DBObject(4, 2, 12));
    arylstParameters.add(new DBObject(5, 2, 12));
    arylstParameters.add(new DBObject(6, 2, 4));
    ArrayList arylstOutArray = oBean.callProc(arylstParameters, "HRMORGDISTRICTMST.proc_GetDistrictDtl(?,?,?,?,?,?)");
    DBObject oOutObject = arylstOutArray.get(0);
    ArrayList arylstList = (ArrayList)oOutObject.getObject();
    if (arylstList.size() == 0)
      throw new EnrgiseApplicationException("wenrgise.hrms.norecordfound", "M"); 
    QueryRow oRow = null;
    QueryValue oValue = null;
    HashMap oColumns = null;
    Iterator itrBean = arylstList.iterator();
    while (itrBean.hasNext()) {
      if (count == 0)
        arylstHrmDistrictDetail = new ArrayList(); 
      count++;
      oRow = itrBean.next();
      HrmOrgDistrictMstDtlBean oDistrictBean = new HrmOrgDistrictMstDtlBean();
      oDistrictBean.setDetailId(oRow.get("ID").getString());
      oDistrictBean.setTxtDistrictCode(oRow.get("CODE").getString());
      oDistrictBean.setTxtDistrictName(oRow.get("DESCRIPTION").getString());
      arylstHrmDistrictDetail.add(oDistrictBean);
    } 
    return arylstHrmDistrictDetail;
  }
  
  public void updateHeaderImpl(BaseHeaderBean oBaseHeaderBean) throws EnrgiseSystemException {
    System.out.println("Update ille!");
  }
  
  public String saveNewHeaderImpl(BaseHeaderBean oBaseHeaderBean) throws EnrgiseSystemException {
    return "saveNewHeaderImpl ille!";
  }
  
  public String saveHeaderImpl(BaseHeaderBean oBaseHeaderBean, String param1) throws EnrgiseSystemException {
    return "true";
  }
  
  public void initializeBOImpl() {
    this.headerTable = "HRM_DISTRICT_MST";
  }
  
  public void saveDetailImpl(String sHeaderPrimaryKey, String sScreenName, ArrayList arylstDetailBeanArray) throws EnrgiseSystemException {
    if (sScreenName.equalsIgnoreCase("HrmOrgDistMst"))
      saveHrmDistrictDetail(arylstDetailBeanArray); 
  }
  
  private void saveHrmDistrictDetail(ArrayList arylstDetailBeanArray) throws EnrgiseSystemException {
    boolean bInsert = false;
    boolean bUpdate = false;
    boolean bDelete = false;
    ArrayList arylstParameters = new ArrayList();
    DBUtilitiesBean oBean = null;
    DBUtilitiesBean oBean1 = null;
    Iterator itrBean = arylstDetailBeanArray.iterator();
    while (itrBean.hasNext()) {
      HrmOrgDistrictMstDtlBean oHrmOrgDistMstDtlBean = itrBean.next();
      if (oHrmOrgDistMstDtlBean.getStatus().equals("N")) {
        if (!bInsert) {
          oBean = new DBUtilitiesBean();
          oBean.createBatch("HRMORGDISTRICTMST.proc_UpsertHrDistrictMst(?,?,?,?,?,?)");
          bInsert = true;
        } 
        arylstParameters = new ArrayList();
        arylstParameters.add(new DBObject(1, 1, 12, "I"));
        arylstParameters.add(new DBObject(2, 1, 12, oHrmOrgDistMstDtlBean.getTxtDistrictCode()));
        arylstParameters.add(new DBObject(3, 1, 12, oHrmOrgDistMstDtlBean.getTxtDistrictName()));
        arylstParameters.add(new DBObject(4, 1, 12, this.oUserInfo.getUserTypeId()));
        arylstParameters.add(new DBObject(5, 1, 12, this.oUserInfo.getSiteId()));
        arylstParameters.add(new DBObject(6, 1, 12, null));
        oBean.addToBatch(arylstParameters);
        continue;
      } 
      if (oHrmOrgDistMstDtlBean.getStatus().equals("U")) {
        if (!bUpdate) {
          oBean = new DBUtilitiesBean();
          oBean.createBatch("HRMORGDISTRICTMST.proc_UpsertHrDistrictMst(?,?,?,?,?,?)");
          bUpdate = true;
        } 
        arylstParameters = new ArrayList();
        arylstParameters.add(new DBObject(1, 1, 12, "U"));
        arylstParameters.add(new DBObject(2, 1, 12, oHrmOrgDistMstDtlBean.getTxtDistrictCode()));
        arylstParameters.add(new DBObject(3, 1, 12, oHrmOrgDistMstDtlBean.getTxtDistrictName()));
        arylstParameters.add(new DBObject(4, 1, 12, this.oUserInfo.getUserTypeId()));
        arylstParameters.add(new DBObject(5, 1, 12, this.oUserInfo.getSiteId()));
        arylstParameters.add(new DBObject(6, 1, 12, oHrmOrgDistMstDtlBean.getDetailId()));
        oBean.addToBatch(arylstParameters);
        continue;
      } 
      if (oHrmOrgDistMstDtlBean.getStatus().equals("D")) {
        if (!bDelete) {
          oBean1 = new DBUtilitiesBean();
          oBean1.createBatch("HRMORGDISTRICTMST.proc_DeleteDistMst(?)");
          bDelete = true;
        } 
        arylstParameters = new ArrayList();
        arylstParameters.add(new DBObject(1, 1, 12, oHrmOrgDistMstDtlBean.getDetailId()));
        oBean1.addToBatch(arylstParameters);
      } 
    } 
    if (bInsert)
      oBean.executeBatch(); 
    if (bUpdate)
      oBean.executeBatch(); 
    if (bDelete)
      oBean1.executeBatch(); 
  }
  
  public void additionalFieldValidationImpl(BaseHeaderBean oBaseHeaderBean, Timestamp oWhenPicked, String sScreenName, String sScreenMode, boolean bHeaderDataChanged, ArrayList arylstDetailBeanArray, boolean bDetailDataChanged, Timestamp oDetailPicked) throws EnrgiseApplicationException, EnrgiseSystemException {
    ArrayList arylstErrorList = new ArrayList();
    if (bDetailDataChanged)
      if (sScreenName.equalsIgnoreCase("HrmOrgDistMst")) {
        Iterator itrBean1 = arylstDetailBeanArray.iterator();
        int iCount = 1;
        while (itrBean1.hasNext()) {
          HrmOrgDistrictMstDtlBean oHrmOrgDistMstDtlBean = itrBean1.next();
          if (!oHrmOrgDistMstDtlBean.getStatus().equalsIgnoreCase("D"))
            checkMandatory(oHrmOrgDistMstDtlBean, iCount, arylstErrorList); 
          iCount++;
        } 
      }  
    reportError(arylstErrorList);
  }
  
  private void checkMandatory(HrmOrgDistrictMstDtlBean oHrmOrgDistMstDtlBean, int iCount, ArrayList arylstErrorList) throws EnrgiseSystemException, EnrgiseApplicationException {
    if (!EnrgiseUtil.checkString(oHrmOrgDistMstDtlBean.getTxtDistrictCode())) {
      MessageKey oMessageKey = new MessageKey("hrm.HrmDistrictMaster.txtCode");
      ArrayList oParams = new ArrayList();
      oParams.add(oMessageKey);
      oParams.add(new Integer(iCount));
      arylstErrorList.add(new EnrgiseMessageKeyException("wenrgise.common.detail.mandatoryFieldMissing", oParams, "E"));
    } 
    if (!EnrgiseUtil.checkString(oHrmOrgDistMstDtlBean.getTxtDistrictName())) {
      MessageKey oMessageKey = new MessageKey("hrm.HrmDistrictMaster.txtDescription");
      ArrayList oParams = new ArrayList();
      oParams.add(oMessageKey);
      oParams.add(String.valueOf(iCount));
      arylstErrorList.add(new EnrgiseMessageKeyException("wenrgise.common.detail.mandatoryFieldMissing", oParams, "E"));
    } 
    reportError(arylstErrorList);
  }
  
  public void additionalBusinessValidationImpl(BaseHeaderBean oBaseHeaderBean, Timestamp oWhenPicked, String sScreenName, String sScreenMode, boolean bHeaderDataChanged, ArrayList arylstDetailBeanArray, boolean bDetailDataChanged, Timestamp oDetailPicked) throws EnrgiseApplicationException, EnrgiseSystemException {
    ArrayList arylstErrorList = new ArrayList();
    if (bDetailDataChanged)
      if (sScreenName.equalsIgnoreCase("HrmOrgDistMst")) {
        Iterator itrBean1 = arylstDetailBeanArray.iterator();
        while (itrBean1.hasNext()) {
          HrmOrgDistrictMstDtlBean oHrmOrgDistMstDtlBean = itrBean1.next();
          if (!oHrmOrgDistMstDtlBean.getStatus().equalsIgnoreCase("D"))
            EnrgiseUtil.checkDuplicate(arylstDetailBeanArray, "txtDistrictCode", "hrm.HrmDistrictMaster.txtCode", arylstErrorList, true); 
        } 
      }  
    reportError(arylstErrorList);
  }
  
  public void additionalTimestampValidationImpl(BaseHeaderBean param1, Timestamp param2, String param3, String param4, boolean param5, ArrayList param6, boolean param7, Timestamp param8) {}
}
